/**
 * BatchRequest.java
 *
 * File generated from the core::BatchRequest uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class BatchRequest.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "BatchRequest", propOrder = {
	"authRequest",
	"batchRequests",
	"onError",
	"processing",
	"requestID",
	"responseOrder"
})
@XmlRootElement(name = "batchRequest")
public class BatchRequest implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "authRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AuthRequest authRequest;
	@XmlElementRefs({
			@XmlElementRef(name = "searchRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "modifyRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "addRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "delRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "modDNRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "compareRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "abandonRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "extendedRequest", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class)
		})
	public List<java.io.Serializable> batchRequests;
	@XmlAttribute(name = "onError")
	public net.ihe.gazelle.hpd.OnErrorType onError;
	@XmlAttribute(name = "processing")
	public net.ihe.gazelle.hpd.ProcessingType processing;
	@XmlAttribute(name = "requestID")
	public java.lang.String requestID;
	@XmlAttribute(name = "responseOrder")
	public net.ihe.gazelle.hpd.ResponseOrderType responseOrder;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return authRequest.
	 * @return authRequest
	 */
	public net.ihe.gazelle.hpd.AuthRequest getAuthRequest() {
	    return authRequest;
	}
	
	/**
	 * Set a value to attribute authRequest.
	 * @param authRequest.
	 */
	public void setAuthRequest(net.ihe.gazelle.hpd.AuthRequest authRequest) {
	    this.authRequest = authRequest;
	}
	
	
	
	
	/**
	 * Return batchRequests.
	 * @return batchRequests
	 */
	public List<java.io.Serializable> getBatchRequests() {
		if (batchRequests == null) {
	        batchRequests = new ArrayList<java.io.Serializable>();
	    }
	    return batchRequests;
	}
	
	/**
	 * Set a value to attribute batchRequests.
	 * @param batchRequests.
	 */
	public void setBatchRequests(List<java.io.Serializable> batchRequests) {
	    this.batchRequests = batchRequests;
	}
	
	
	
	/**
	 * Add a batchRequests to the batchRequests collection.
	 * @param batchRequests_elt Element to add.
	 */
	public void addBatchRequests(java.io.Serializable batchRequests_elt) {
	    this.getBatchRequests().add(batchRequests_elt);
	}
	
	/**
	 * Remove a batchRequests to the batchRequests collection.
	 * @param batchRequests_elt Element to remove
	 */
	public void removeBatchRequests(java.io.Serializable batchRequests_elt) {
	    this.getBatchRequests().remove(batchRequests_elt);
	}
	
	/**
	 * Return searchRequest.
	 * @return searchRequest
	 */
	public List<net.ihe.gazelle.hpd.SearchRequest> getSearchRequest() {
		List<net.ihe.gazelle.hpd.SearchRequest> searchRequest_el = new ArrayList<net.ihe.gazelle.hpd.SearchRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("searchRequest")){
					searchRequest_el.add( (net.ihe.gazelle.hpd.SearchRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return searchRequest_el;
	}
	
	public void addSearchRequest(net.ihe.gazelle.hpd.SearchRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.SearchRequest> jobj = of.createBatchRequestSearchRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return modifyRequest.
	 * @return modifyRequest
	 */
	public List<net.ihe.gazelle.hpd.ModifyRequest> getModifyRequest() {
		List<net.ihe.gazelle.hpd.ModifyRequest> modifyRequest_el = new ArrayList<net.ihe.gazelle.hpd.ModifyRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("modifyRequest")){
					modifyRequest_el.add( (net.ihe.gazelle.hpd.ModifyRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return modifyRequest_el;
	}
	
	public void addModifyRequest(net.ihe.gazelle.hpd.ModifyRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.ModifyRequest> jobj = of.createBatchRequestModifyRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return addRequest.
	 * @return addRequest
	 */
	public List<net.ihe.gazelle.hpd.AddRequest> getAddRequest() {
		List<net.ihe.gazelle.hpd.AddRequest> addRequest_el = new ArrayList<net.ihe.gazelle.hpd.AddRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("addRequest")){
					addRequest_el.add( (net.ihe.gazelle.hpd.AddRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return addRequest_el;
	}
	
	public void addAddRequest(net.ihe.gazelle.hpd.AddRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AddRequest> jobj = of.createBatchRequestAddRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return delRequest.
	 * @return delRequest
	 */
	public List<net.ihe.gazelle.hpd.DelRequest> getDelRequest() {
		List<net.ihe.gazelle.hpd.DelRequest> delRequest_el = new ArrayList<net.ihe.gazelle.hpd.DelRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("delRequest")){
					delRequest_el.add( (net.ihe.gazelle.hpd.DelRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return delRequest_el;
	}
	
	public void addDelRequest(net.ihe.gazelle.hpd.DelRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.DelRequest> jobj = of.createBatchRequestDelRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return modDNRequest.
	 * @return modDNRequest
	 */
	public List<net.ihe.gazelle.hpd.ModifyDNRequest> getModDNRequest() {
		List<net.ihe.gazelle.hpd.ModifyDNRequest> modDNRequest_el = new ArrayList<net.ihe.gazelle.hpd.ModifyDNRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("modDNRequest")){
					modDNRequest_el.add( (net.ihe.gazelle.hpd.ModifyDNRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return modDNRequest_el;
	}
	
	public void addModDNRequest(net.ihe.gazelle.hpd.ModifyDNRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.ModifyDNRequest> jobj = of.createBatchRequestModDNRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return compareRequest.
	 * @return compareRequest
	 */
	public List<net.ihe.gazelle.hpd.CompareRequest> getCompareRequest() {
		List<net.ihe.gazelle.hpd.CompareRequest> compareRequest_el = new ArrayList<net.ihe.gazelle.hpd.CompareRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("compareRequest")){
					compareRequest_el.add( (net.ihe.gazelle.hpd.CompareRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return compareRequest_el;
	}
	
	public void addCompareRequest(net.ihe.gazelle.hpd.CompareRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.CompareRequest> jobj = of.createBatchRequestCompareRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return abandonRequest.
	 * @return abandonRequest
	 */
	public List<net.ihe.gazelle.hpd.AbandonRequest> getAbandonRequest() {
		List<net.ihe.gazelle.hpd.AbandonRequest> abandonRequest_el = new ArrayList<net.ihe.gazelle.hpd.AbandonRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("abandonRequest")){
					abandonRequest_el.add( (net.ihe.gazelle.hpd.AbandonRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return abandonRequest_el;
	}
	
	public void addAbandonRequest(net.ihe.gazelle.hpd.AbandonRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AbandonRequest> jobj = of.createBatchRequestAbandonRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return extendedRequest.
	 * @return extendedRequest
	 */
	public List<net.ihe.gazelle.hpd.ExtendedRequest> getExtendedRequest() {
		List<net.ihe.gazelle.hpd.ExtendedRequest> extendedRequest_el = new ArrayList<net.ihe.gazelle.hpd.ExtendedRequest>();
			for(java.io.Serializable obj : this.getBatchRequests()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("extendedRequest")){
					extendedRequest_el.add( (net.ihe.gazelle.hpd.ExtendedRequest) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return extendedRequest_el;
	}
	
	public void addExtendedRequest(net.ihe.gazelle.hpd.ExtendedRequest obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.ExtendedRequest> jobj = of.createBatchRequestExtendedRequest(obj);
		this.getBatchRequests().add(jobj);
	}
	
	/**
	 * Return onError.
	 * @return onError
	 */
	public net.ihe.gazelle.hpd.OnErrorType getOnError() {
	    return onError;
	}
	
	/**
	 * Set a value to attribute onError.
	 * @param onError.
	 */
	public void setOnError(net.ihe.gazelle.hpd.OnErrorType onError) {
	    this.onError = onError;
	}
	
	
	
	
	/**
	 * Return processing.
	 * @return processing
	 */
	public net.ihe.gazelle.hpd.ProcessingType getProcessing() {
	    return processing;
	}
	
	/**
	 * Set a value to attribute processing.
	 * @param processing.
	 */
	public void setProcessing(net.ihe.gazelle.hpd.ProcessingType processing) {
	    this.processing = processing;
	}
	
	
	
	
	/**
	 * Return requestID.
	 * @return requestID
	 */
	public java.lang.String getRequestID() {
	    return requestID;
	}
	
	/**
	 * Set a value to attribute requestID.
	 * @param requestID.
	 */
	public void setRequestID(java.lang.String requestID) {
	    this.requestID = requestID;
	}
	
	
	
	
	/**
	 * Return responseOrder.
	 * @return responseOrder
	 */
	public net.ihe.gazelle.hpd.ResponseOrderType getResponseOrder() {
	    return responseOrder;
	}
	
	/**
	 * Set a value to attribute responseOrder.
	 * @param responseOrder.
	 */
	public void setResponseOrder(net.ihe.gazelle.hpd.ResponseOrderType responseOrder) {
	    this.responseOrder = responseOrder;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "batchRequest").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(BatchRequest batchRequest, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (batchRequest != null){
   			cvm.validate(batchRequest, _location, diagnostic);
			net.ihe.gazelle.hpd.AuthRequest.validateByModule(batchRequest.getAuthRequest(), _location + "/authRequest", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.SearchRequest searchRequest: batchRequest.getSearchRequest()){
					net.ihe.gazelle.hpd.SearchRequest.validateByModule(searchRequest, _location + "/searchRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.ModifyRequest modifyRequest: batchRequest.getModifyRequest()){
					net.ihe.gazelle.hpd.ModifyRequest.validateByModule(modifyRequest, _location + "/modifyRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AddRequest addRequest: batchRequest.getAddRequest()){
					net.ihe.gazelle.hpd.AddRequest.validateByModule(addRequest, _location + "/addRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.DelRequest delRequest: batchRequest.getDelRequest()){
					net.ihe.gazelle.hpd.DelRequest.validateByModule(delRequest, _location + "/delRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.ModifyDNRequest modDNRequest: batchRequest.getModDNRequest()){
					net.ihe.gazelle.hpd.ModifyDNRequest.validateByModule(modDNRequest, _location + "/modDNRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.CompareRequest compareRequest: batchRequest.getCompareRequest()){
					net.ihe.gazelle.hpd.CompareRequest.validateByModule(compareRequest, _location + "/compareRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AbandonRequest abandonRequest: batchRequest.getAbandonRequest()){
					net.ihe.gazelle.hpd.AbandonRequest.validateByModule(abandonRequest, _location + "/abandonRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.ExtendedRequest extendedRequest: batchRequest.getExtendedRequest()){
					net.ihe.gazelle.hpd.ExtendedRequest.validateByModule(extendedRequest, _location + "/extendedRequest[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}